/*  ppmmargin - add a margin to a portable anymap */
/*
# Copyright (C) 1991 by Jef Poskanzer.
#
# Permission to use, copy, modify, and distribute this software and its
# documentation for any purpose and without fee is hereby granted, provided
# that the above copyright notice appear in all copies and that both that
# copyright notice and this permission notice appear in supporting
# documentation.  This software is provided "as is" without express or
# implied warranty.
*/

program = "pnmmargin"

color="-gofigure"

/* Parse args. */
parse arg params

if ((words(params) = 0) | (words(params) > 4)) then
  do
  say "usage: "program" [-white|-black|-color <colorspec>] <size> [pnmfile]"
  exit 1
  end

parse var params word rest
if (word = "-white") | (word = "-black") | (word = "-color") then
   do
   if (word = "-white") | (word = "-black") then
      color = word
   else
      parse var rest color rest
   end
else
  do
  color = "-gofigure"
  rest = params
  end

parse var rest size rest
parse var rest pnmfile
/*
say "color = "color
say "size = "size
say "pnmfile = "pnmfile
*/

tmp1= TmpFile()
tmp2= TmpFile()
tmp3= TmpFile()
tmp4= TmpFile()

/* Capture input file in a tmp file, in case it's a pipe. */
"@cat "pnmfile" > "tmp1

/* Construct spacer files. */
select
    when color ="-gofigure" then
      "@pnmcut 0 0 1 1 "tmp1" | pnmtile "size" 1 > "tmp2
    when (color="-white")|(color="-black") then
      "@pbmmake "color" "size" 1 > "tmp2
    otherwise
      "@ppmmake "color" "size" 1 > "tmp2
    end /* select */
"@pnmflip -rotate90 "tmp2" > "tmp3

/* Cat things together. */
"@pnmcat -lr "tmp2" "tmp1" "tmp2" > "tmp4
"@pnmcat -tb "tmp3" "tmp4" "tmp3

/* All done. */
call LineOut tmp1
call LineOut tmp2
call LineOut tmp3
call LineOut tmp4
call SysFileDelete tmp1
call SysFileDelete tmp2
call SysFileDelete tmp3
call SysFileDelete tmp4

exit


ChkRexxUtil: Procedure
/* 1999? */

/* Returns 0 if RexxUtil can/has been loaded properly, 1 else */

if RxFuncQuery('SysLoadFuncs') = 1 then
   do
   if RxFuncAdd('SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs') <> 0 then
      return 1
   else
     do
     call SysLoadFuncs
     return 0
     end
   end
else
  do
  call SysLoadFuncs
  return 0
  end


SlashifyS: PROCEDURE
/* converts all '\' into '/' */

Parse Arg input
output = Translate( input, '/', '\' )
return output


BslashifyS: PROCEDURE
/* converts all '/' into '\' */

Parse Arg input
output = Translate( input, '\', '/' )
return output


TmpFile: Procedure
/* 980509 */

if ChkRexxUtil() = 1 then
  return ""
tmpdir = Strip(BslashifyS(Value('TMP', , 'OS2ENVIRONMENT')), 'T', '\')
if tmpdir = "" then
  tmpdir = Strip(BslashifyS(Value('TEMP', , 'OS2ENVIRONMENT')), 'T', '\')
if tmpdir = "" then
  tmpdir = Directory()
template = tmpdir"\AMRS.???"
tf_name = SysTempFileName(template)
return tf_name
