/* ps2gif */
/*
#!/bin/sh
#ps2gif script by Ian Hutchinson 1998; use at your own risk.
#You need Ghostscript and the pbmplus utilities installed. 
*/

gs_cmd = "@gs "
parse arg psfile giffile iconfile

if giffile = "" then
   do
   say " Usage: ps2gif <file.ps> <file.gif> [<icon.gif>]"
   exit 1
   end
else 
   do
   ppmfile = TmpFile()
   say "Calling ghostscript to convert, please wait ..."
/*
   gs_cmd " -sDEVICE=ppmraw -sOutputFile=- -sNOPAUSE -q "psfile"  -c showpage -c quit | pnmcrop| pnmmargin -white 10 | ppmtogif >"giffile
*/
   gs_cmd " -sDEVICE=ppmraw -sOutputFile="ppmfile" -sNOPAUSE -q "psfile"  -c showpage -c quit"
   "pnmcrop <"ppmfile" | pnmmargin -white 10 | ppmtogif >"giffile
   if iconfile <> "" then
      do
/* Make an icon file. */
/*
      gs_cmd "-sDEVICE=ppmraw -sOutputFile=- -sNOPAUSE -r12 -q "psfile"  -c showpage -c quit | pnmcrop|  ppmtogif >"iconfile
*/
      gs_cmd "-sDEVICE=ppmraw -sOutputFile="ppmfile" -sNOPAUSE -r12 -q "psfile"  -c showpage -c quit"
      "pnmcrop <"ppmfile" |  ppmtogif >"iconfile
      end
   end
call SysFileDelete ppmfile
exit


SlashifyS: PROCEDURE
/* converts all '\' into '/' */

Parse Arg input
output = Translate( input, '/', '\' )
return output


BslashifyS: PROCEDURE
/* converts all '/' into '\' */

Parse Arg input
output = Translate( input, '\', '/' )
return output


TmpFile: Procedure

if ChkRexxUtil() = 1 then
  return ""
tmpdir = Strip(BslashifyS(Value('TMP', , 'OS2ENVIRONMENT')), 'T', '\')
if tmpdir = "" then
  tmpdir = Strip(BslashifyS(Value('TEMP', , 'OS2ENVIRONMENT')), 'T', '\')
if tmpdir = "" then
  tmpdir = Directory()
template = tmpdir"\p2g??.ppm"
tf_name = SysTempFileName(template)
return tf_name

ChkRexxUtil: Procedure
/* 1999? */

/* Returns 0 if RexxUtil can/has been loaded properly, 1 else */

if RxFuncQuery('SysLoadFuncs') = 1 then
   do
   if RxFuncAdd('SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs') <> 0 then
      return 1
   else
     do
     call SysLoadFuncs
     return 0
     end
   end
else
  do
  call SysLoadFuncs
  return 0
  end
